void	main(void)
{
	char			cMemTags;
	CTabHandle	ctable;
	GDHandle		devH;
	RGBColor		brownTint;
	short		i;

	brownTint.red = 59193;
	brownTint.green = 40167;
	brownTint.blue = 23254;
		
	devH = GetGDevice();
	ctable = GetCTable(128);
	
	for(i = 0;i < (*ctable)->ctSize;i++)
	{
		(*ctable)->ctTable[i].rgb.red = ((*ctable)->ctTable[i].rgb.red + brownTint.red) / 2;
		(*ctable)->ctTable[i].rgb.green = ((*ctable)->ctTable[i].rgb.green + brownTint.green) / 2;
		(*ctable)->ctTable[i].rgb.blue = ((*ctable)->ctTable[i].rgb.blue + brownTint.blue) / 2;
	}
	
	cMemTags = HGetState((Handle)devH);	
	
	HLock((Handle)devH);
	HLock((Handle)ctable); 

	BlockMoveData((*ctable)->ctTable,
	(*(*(*devH)->gdPMap)->pmTable)->ctTable,
	sizeof(ColorSpec) * (*(*(*devH)->gdPMap)->pmTable)->ctSize+1);
	
	(*(*(*devH)->gdPMap)->pmTable)->ctSeed = (*ctable)->ctSeed;
	(*(*(*devH)->gdPMap)->pmTable)->ctFlags = (*ctable)->ctFlags;
	(*(*(*devH)->gdPMap)->pmTable)->ctSize = (*ctable)->ctSize;
	
	HSetState((Handle)devH,cMemTags);
	SetGDevice(devH);
	MakeITable(nil,nil,8);
	
	HUnlock((Handle)ctable);
	DisposeCTable(ctable);
}